Inconsistent C source code indentation

12/27/2017 09:22 AM - shyouhei (Shyouhei Urabe)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:

UNKNOWN

Description

I would like to focus on following 238 C source codes in our repository.

% git ls-files | grep '\.\(c\|h\|def\)$' | grep -v 'ext|spec|test' | wc -l

238

 Here, in these 238 files, 10 files are indented using spaces only.

% git ls-files | grep '\.\(c\|h\|def\)$' | grep -v 'ext|spec|test' | \

xargs grep --files-without-match $'^\t' | xargs grep --files-with-match '^        ' | wc -l

10

 On the other hand 66 files are indented using tabs.

% git ls-files | grep '\.\(c\|h\|def\)$' | grep -v 'ext|spec|test' | \

xargs grep --files-with-match $'^\t' | xargs grep --files-without-match '^        ' | wc -l

66

 Other 61 files do not indent.  We should not bother them.

% git ls-files | grep '\.\(c\|h\|def\)$' | grep -v 'ext|spec|test' | \

xargs grep --files-without-match $'^\t' | xargs grep --files-without-match '^        ' | wc -l

61

 So far so good.  But what about remaining 101 files?  The answer is obvious; these files MIX indents.

% git ls-files | grep '\.\(c\|h\|def\)$' | grep -v 'ext|spec|test' | \

xargs grep --files-with-match $'^\t' | xargs grep --files-with-match '^        ' | wc -l

101

 This is totally wrong.  No matter should we use spaces or tabs for indentations, it must be consistent.

Related issues:

Related to Ruby - Misc #16112: Reduce the possibility of "expand tabs" commit... Closed

Associated revisions

Revision 224bbbdc3a7662654cae0deea9b6387a1a657599 - 01/25/2018 12:11 AM - znz (Kazuhiro NISHIYAMA)

.editorconfig: Use spaces instead of tab except Makefiles

ref [Bug #14246]

[ci skip]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@62033 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 224bbbdc - 01/25/2018 12:11 AM - znz (Kazuhiro NISHIYAMA)

.editorconfig: Use spaces instead of tab except Makefiles

ref [Bug #14246]

[ci skip]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@62033 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision b83ae7476ef12014c26f0666f46e72d1837ffce0 - 03/17/2018 02:37 AM - k0kubun (Takashi Kokubun)

misc/ruby-style.el: use spaces for indentation

instead of hard tabs.

[Bug #14246]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@62789 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b83ae747 - 03/17/2018 02:37 AM - k0kubun (Takashi Kokubun)

misc/ruby-style.el: use spaces for indentation

instead of hard tabs.

[Bug #14246]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@62789 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision acc48fce30b413c158d06e5578ac73b07ed60b69 - 06/06/2018 06:14 AM - yui-knk (Kaneko Yuichiro)

ast.c: Change tabs to spaces

ast.c: I created a new C source code file with tabs and spaces mixed

format by mistake. Currently we move to spaces only.

Surely we agreed not to batch update. But ast.c is a new

source code. So please forgive me to change the format before

many changes are committed this file.

I'm sorry about my mistake.

ref [Bug #14246]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63586 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision acc48fce30b413c158d06e5578ac73b07ed60b69 - 06/06/2018 06:14 AM - yui-knk (Kaneko Yuichiro)

ast.c: Change tabs to spaces

ast.c: I created a new C source code file with tabs and spaces mixed

format by mistake. Currently we move to spaces only.

Surely we agreed not to batch update. But ast.c is a new

source code. So please forgive me to change the format before

many changes are committed this file.

I'm sorry about my mistake.

ref [Bug #14246]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63586 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision acc48fce - 06/06/2018 06:14 AM - yui-knk (Kaneko Yuichiro)

ast.c: Change tabs to spaces

ast.c: I created a new C source code file with tabs and spaces mixed

format by mistake. Currently we move to spaces only.

Surely we agreed not to batch update. But ast.c is a new

source code. So please forgive me to change the format before

many changes are committed this file.

I'm sorry about my mistake.

ref [Bug #14246]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63586 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 36fa6af2e831e40fe318f1e68b389c83a853521a - 07/01/2018 01:38 AM - znz (Kazuhiro NISHIYAMA)

[DOC] newer codes recommend to use spaces only

[Bug #14246]

[ci skip]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63811 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
[DOC] newer codes recommend to use spaces only

[Bug #14246]

[ci skip]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63811 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 36fa6af2 - 07/01/2018 01:38 AM - znz (Kazuhiro NISHIYAMA)

[DOC] newer codes recommend to use spaces only

[Bug #14246]

[ci skip]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63811 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 12/27/2017 10:19 AM - duerst (Martin Dürst)

I'm all for better consistency. I thought there were clear guidelines for Ruby, and (almost) everybody was following them. I didn't know it was that bad.

But fixing spacing will obscure where the code originally came from. I don't really like that.

To improve the situation, I have the following suggestions:

1. Install an SVN bot that fixes indents on newly committed lines automatically. That would hopefully catch the attention of the committers.

2. Based on svn blame, get a picture of who is how good (or not) at following the guidelines, and gently nudge everybody in the right direction.

[Somebody sooner or later will start discussion on what the best way of indenting should be. If you want to do this, please make it a separate issue.

Please tag it as "joke" (because we don't have a "bikeshed" category).]

#2 - 12/27/2017 10:36 AM - shyouhei (Shyouhei Urabe)

- Description updated

#3 - 12/27/2017 11:08 AM - normalperson (Eric Wong)

duerst@it.aoyama.ac.jp wrote:

I'm all for better consistency. I thought there were clear

guidelines for Ruby, and (almost) everybody was following

them. I didn't know it was that bad.

 Right, I remember it being 4 spaces per-level, and use TAB

whenever it's 8 spaces.  AFAIK, that's the Emacs default and I've

seen this in several other projects, so not uncommon..

In vim, I use: :set ts=8 sw=4 sts=4 noexpandtab

But fixing spacing will obscure where the code originally came

from. I don't really like that.

 Agreed 100%.  Noise makes code archaelogy harder, I don't like

whitespace-only changes; but I'd be happy to see them if one is

in the affected area and already changing code, and the proposed

SVN bot might help with that...

I admit that I moved some existing all-space code not long ago

and did not notice it, but nobu fixed it for me :x

To improve the situation, I have the following suggestions:

 1. Install an SVN bot that fixes indents on newly committed

lines automatically. That would hopefully catch the attention

of the committers.

 Instead of auto-fixing, it should email the committer;

that ought to reduce future screwups.
#4 - 12/30/2017 01:29 PM - znz (Kazuhiro NISHIYAMA)

I think that guidelines are .editorconfig for most editors, misc/ruby-style.el for Emacs, and .indent.pro for indent.

#5 - 01/05/2018 06:13 PM - vo.x (Vit Ondruch)

Let me quote Developers How-To 1:

indent

4 for C

2 for Ruby

tab/space

Do not use TABs in ruby codes ruby-dev:19388

Use TAB instead of 8 SPs in C. (Emacs's default style)

#6 - 01/05/2018 08:46 PM - naruse (Yui NARUSE)

Just FYI, there's a format tool named clang-format.

https://clang.llvm.org/docs/ClangFormat.html

I use following options:

https://github.com/nurse/strptime/blob/master/.clang-format

#7 - 01/14/2018 05:56 PM - graywolf (Gray Wolf)

As @vo.x already pointed out, there are guidelines for the indentation. So based on the guidelines the 101 files are (probably) correctly indented and

the 76 (10 + 66) files are (probably) wrongly indented.

#8 - 01/15/2018 02:26 AM - shyouhei (Shyouhei Urabe)

@graywolf we are talking about C codes here.  The "Do not use TABs" policy applies to non-C files.

#9 - 01/15/2018 02:37 AM - graywolf (Gray Wolf)

I can't count to 8 in

xargs grep --files-with-match '^        '`

 , sorry, just ignore me. :/

#10 - 01/24/2018 08:00 AM - shyouhei (Shyouhei Urabe)

We discussed this issue in today's developer meeting.

We agreed not to batch update the indents at once.  Indents should become consistent over time.

Matz has no strong opinion on this topic.

We agreed to move to spaces only.  Reasons behind this:

No contemporary advantage of mixing tabs and spaces today.

Emacs fans at the meeting could use ruby-style.el, and that style can be updated.

So the next action is:

Modify ruby-style.el and other config files.

Use them.

#11 - 01/25/2018 12:11 AM - Anonymous

- Status changed from Open to Closed

Applied in changeset trunk|r62033.

.editorconfig: Use spaces instead of tab except Makefiles

ref [Bug #14246]

[ci skip]

#12 - 01/31/2018 12:04 PM - znz (Kazuhiro NISHIYAMA)

- Status changed from Closed to Open

Re-open because accidentally closed.
At least misc/ruby-style.el set to tabs.

#13 - 03/17/2018 02:37 AM - k0kubun (Takashi Kokubun)

- Status changed from Open to Closed

Applied in changeset trunk|r62789.

misc/ruby-style.el: use spaces for indentation

instead of hard tabs.

[Bug #14246]

#14 - 08/21/2019 01:25 PM - k0kubun (Takashi Kokubun)

- Related to Misc #16112: Reduce the possibility of "expand tabs" commit occurrences added

#15 - 05/26/2022 02:58 AM - ioquatix (Samuel Williams)

https://github.com/ruby/ruby/pull/5946 experiment with clang-format.

#16 - 06/24/2022 04:22 AM - ioquatix (Samuel Williams)

Does this policy apply to the formatting of default gems too?

#17 - 06/27/2022 12:28 AM - shyouhei (Shyouhei Urabe)

ioquatix (Samuel Williams) wrote in #note-16:

Does this policy apply to the formatting of default gems too?

 I don't think so.  One good thing about splitting things into gems is they can have their own policies (release timing etc.).  I support each gems having

distinct point of view as to what code is a beautiful code.
